﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DotSpatial.Controls;
using DotSpatial.Data;
//using DotSpatial.Topology;
using DotSpatial.Symbology;
using System.Web;

namespace DotSpatialHelloWorld
{
    public partial class frmIdentify : Form
    {
        private IFeatureLayer layer;
        private List<IFeature> features;
        public frmMap fm;
        public frmIdentify()
        {
            InitializeComponent();
        }


        private void ShowAttributes(int ord) {
            IFeature f = features[ord];
            if (f == null) return;
            DataTable dt = new DataTable();
            dt.Columns.Add("Field Name");
            dt.Columns.Add("Value");

            if (f.DataRow == null)
            {
                f.ParentFeatureSet.FillAttributes();
            }
            DataColumn[] columns = f.ParentFeatureSet.GetColumns();
            foreach (DataColumn fld in columns)
            {
                DataRow dr = dt.NewRow();
                dr["Field Name"] = fld.ColumnName;
                if (f.DataRow != null) dr["Value"] = f.DataRow[fld.ColumnName].ToString();
                dt.Rows.Add(dr);
            }
            dgAttributes.DataSource = dt;
        }

        public void Add(IFeatureLayer layer, Extent bounds)
        {
            this.layer = layer;
            features = layer.DataSet.Select(bounds);
            foreach (IFeature feature in features)
            {
                /*if (feature.DataRow[fm.fldIdentify] == null)
                {
                    cmbFid.Items.Add("Nemá atribut " + fm.fldIdentify);
                }
                else
                {
                    //cmbFid.Items.Add(feature.Fid);
                    cmbFid.Items.Add(feature.DataRow[fm.fldIdentify].ToString());
                }*/
                cmbFid.Items.Add(feature.Fid);
            }
            cmbFid.SelectedIndex = 0;
            ShowAttributes(cmbFid.SelectedIndex);
        }

        private void cmbFid_SelectedIndexChanged(object sender, EventArgs e)
        {
            ShowAttributes(cmbFid.SelectedIndex);
        }

        private void frmIdentify_Load(object sender, EventArgs e)
        {

        }

        private void axAnimation1_Enter(object sender, EventArgs e)
        {
            //am1.Open("Wildlife.wmv");
            //am1.Play();
        }

        private void axWindowsMediaPlayer1_Enter(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Pouze ukazka - nutno spojit s tabulkou
            //axWindowsMediaPlayer1.openPlayer(@"C:\Users\Public\Videos\Sample Videos\Wildlife.wmv"); //otevre v samostatnem okne
            axWindowsMediaPlayer1.URL = @"C:\Users\Public\Videos\Sample Videos\Wildlife.wmv"; //otevre embeded
        }

        private void btnPDF_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("C:\\file.pdf");
        }
    }
}
