﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DotSpatial.Controls;
using DotSpatial.Data;
using DotSpatial.Topology;
using DotSpatial.Symbology;
using System.IO;
using System.ComponentModel.Composition;

namespace DotSpatialHelloWorld
{
    
    public partial class frmMap : Form
    {
        //[Export("Shell", typeof(ContainerControl))]
        //private static ContainerControl Shell;    
        public String fldIdentify = "name";
        public frmMap()
        {
            InitializeComponent();
            //Shell = this;
            //appManager1.LoadExtensions();
        }

        private void frmMap_Load(object sender, EventArgs e)
        {
            initialize();
        }

        private void initialize() {
            legendMain.AddMapFrame(mapMain.MapFrame);
            mapMain.FunctionMode = FunctionMode.Pan;
        }

        private void addLayer()
        {
            mapMain.AddLayer();
        }

        private void zoomToMaxExtent()
        {
            mapMain.ZoomToMaxExtent();
            //mapMain.ViewExtents = new DotSpatial.Data.Extent(16, 50, 17, 51);
            //map1.Refresh();
        }

        private void showZoom()
        {
            frmZoomToExtent f = new frmZoomToExtent();
            f.mapX = mapMain;
            f.Show();
            //f.ShowDialog(this);
        }

        private void showTable()
        {
            frmTable ft = new frmTable();
            IMapFeatureLayer layer = (IMapFeatureLayer) mapMain.Layers[0];
            ft.dataGridView1.DataSource = layer.DataSet.DataTable;
            ft.map1 = mapMain;
            ft.Show();
        }

        private void mapMain_Load(object sender, EventArgs e)
        {

        }

        private void mapMain_DoubleClick(object sender, EventArgs e)
        {
            addLayer();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            addLayer();
        }

        private void tsbZoomForm_Click(object sender, EventArgs e)
        {
            showZoom();
        }

        private void tsbTable_Click(object sender, EventArgs e)
        {
            showTable();
        }

        private void tsbIdentify_Click(object sender, EventArgs e)
        {
            //mapMain.FunctionMode = FunctionMode.Info;
            mapMain.FunctionMode = FunctionMode.None;
        }

        private void tsbPan_Click(object sender, EventArgs e)
        {
            mapMain.FunctionMode = FunctionMode.Pan;
        }

        private void tsbFullExtent_Click(object sender, EventArgs e)
        {
            zoomToMaxExtent();
        }

        private void mapMain_Click(object sender, EventArgs e)
        {
            if (mapMain.FunctionMode == FunctionMode.None)
            {
                frmIdentify fi = new frmIdentify();
                GeoMouseArgs args = new GeoMouseArgs((MouseEventArgs) e, mapMain);
                Envelope env = new Envelope(args.GeographicLocation);
                env.ExpandBy(mapMain.Extent.Width / 10);
                fi.Add((IFeatureLayer) mapMain.Layers[0], env.ToExtent());
                fi.Show();
            }
        }

        private void openCSVToolStripMenuItem_Click(object sender, EventArgs e)
        {
            /*Zdroje:
             * http://dotspatial.codeplex.com/discussions/436929
             * http://stackoverflow.com/questions/2069048/setting-the-filter-to-an-openfiledialog-to-allow-the-typical-image-formats 
             * http://dotspatial.codeplex.com/wikipage?title=Desktop_SampleCode
             * https://sharpmap.svn.codeplex.com/svn/Branches/0.9.5-DeltaShell/src_/Common/NetTopologySuite/IO/GML2/GMLReader.cs
            */
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "csv files (*.csv; *.txt)|*.csv;*.txt|All files (*.*)|*.*";
            dialog.InitialDirectory = @"C:\";
            dialog.Title = "Vyberte CSV pro vytvoření vrstvy.";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                StreamReader reader = new StreamReader(dialog.FileName);
                FeatureSet fs = new FeatureSet(FeatureType.Point);
                String line = reader.ReadLine();
                int xpos = -1;
                int ypos = -1;
                if (line != null) {
                    string[] words = line.Split(';');
                    int i = 0;
                    foreach (string word in words)
                    {
                        //Console.WriteLine(word);
                        fs.DataTable.Columns.Add(word);
                        if (word == "x") xpos = i;
                        if (word == "y") ypos = i;
                        i++;
                    }
                }
                //Pokud nemá sloupce X, Y pak neděláme nic
                if (xpos != -1 && ypos != -1)
                {
                    while ((line = reader.ReadLine()) != null)
                    {
                        string[] words = line.Split(';');
                        double x, y;
                        if (!Double.TryParse(words[xpos], out x)) {
                            MessageBox.Show("Chyba pri prevodu souradnice X: " + words[xpos]);
                            continue;
                        }
                        if (!Double.TryParse(words[ypos], out y)) {
                            MessageBox.Show("Chyba pri prevodu souradnice Y: " + words[ypos]);
                            continue;
                        }
                        IFeature feature = fs.AddFeature(new DotSpatial.Topology.Point(x, y));
                        feature.DataRow.BeginEdit();
                        for (int i = 0; i < words.Length; i++)
                        {
                            feature.DataRow[i] = words[i];
                        }
                        feature.DataRow.EndEdit();
                        //fs.DataTable.Rows.Add();
                        //fs.DataTable.Rows[0].SetField("name", "AAAA");
                    }
                    MapPointLayer csvLayer = new MapPointLayer(fs);
                    csvLayer.Symbolizer = new PointSymbolizer(Color.Blue, DotSpatial.Symbology.PointShape.Star, 15);
                    csvLayer.LegendText = "CSV Layer";
                    mapMain.Layers.Add(csvLayer);
                    fs.SaveAs("C:\\Temp\\roads_test.shp", true);
                }
                else
                {
                    MessageBox.Show("Nenasel jsem sloupce X, Y");
                }
            }           
        }

        private void layerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmLayerConfig frmlc = new frmLayerConfig();
            frmlc.fm = this;
            frmlc.ShowDialog();
        }
    }
}
